unit uExchangeBackground;

interface

uses
  Classes, ComObj, SysUtils, Windows, uMain, IdFTP, IdFTPCommon;

  procedure StartExchangeBackground;

var
  FTP: TIdFTP;
  NeedUpdate: Boolean; //   
  StartPing: Boolean; //  ,    

implementation

uses
  uThreadUpdateProgress, uThreadPing;

//*****************************************************************************//
//    COM
function CreateComConnection(SingleSetting: Settings):Variant;
var
  ConnectionObj: Variant;
  ConnectionString: String;
  SrvrStr: TStrings;
begin
  //   1
  ConnectionObj:=CreateOleObject('v81.ComConnector');
  if SingleSetting.DBType = 0 then
  begin
    ConnectionString:='file='+ SingleSetting.DBPath+';'+' usr='+SingleSetting.DBUserName+';'+' pwd='+SingleSetting.DBUserPassword;
  end else
  begin
    //       
    SrvrStr := StrRefresh(SingleSetting.DBPath, '\');
    ConnectionString:='srvr='+ SrvrStr[0]+';'+ ' ref=' + SrvrStr[1] +  ';' + ' usr='+SingleSetting.DBUserName+';'+' pwd='+SingleSetting.DBUserPassword;
  end;
  Result:=ConnectionObj.Connect(ConnectionString);
end;

///////////////////////////////////////////////////////////////////////////////
//    
procedure UpdateCfg(SingleSetting: Settings);
var
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  UpdateString: String;
begin
  //   
  FillChar(StartupInfo, SizeOf(StartupInfo), #0);
  StartupInfo.cb:=SizeOf(StartupInfo);
  //     
  UpdateString:= MainData.RunPath + ' CONFIG /F' + SingleSetting.DBPath + ' /N' +
               SingleSetting.DBUserName + ' /P' + SingleSetting.DBUserPassword + ' /UpdateDBCfg';

  //  
  CreateProcess(nil, PChar(UpdateString), nil, nil, false, CREATE_NEW_CONSOLE, nil, nil, StartupInfo, ProcessInfo);

  while WaitForSingleObject(ProcessInfo.hProcess, 500) <> WAIT_OBJECT_0 do
  begin
    Sleep(1000);
  end;
end;

//*****************************************************************************//
//     
procedure StartSingleExchange(i: Byte; var Error: Boolean);
var
//  ErrString: String[255]; //     
  SingleSetting: Settings;
  Connection : Variant; // Com-
  SetExchange: Variant; //  -     ""
  countConn: Byte; //     
begin
  SingleSetting := MainData.Data[i];
  //     
  try
    Connection := CreateComConnection(SingleSetting);
  except
  on E:Exception do
    begin
      WriteLog(i, '     ', ' !' + #13#10 + E.Message, True);
      Error := True;
      Exit;
    end;
  end;

  //     
  try
    SetExchange := Connection...(SingleSetting.ExchangeCode);
    if SetExchange.() then
    begin
      WriteLog(i, '   ', ' !' + #13#10 + '    ' + SingleSetting.ExchangeCode + '  !', True);
      Error := True;
      Exit;
    end;
  except
  on E:Exception do
    begin
      WriteLog(i, '   ', '     !' + #13#10 + E.Message, True);
      Error := True;
      Exit;
    end;
  end;

  //        
  Connection..(SetExchange);

  //  ,  -    
  NeedUpdate := Connection.();

  if NeedUpdate then
  begin
    countConn := Connection.().();
    if countConn > 1 then
    begin
      //    
      if SingleSetting.WaitExchangeBg then
      begin
        //        
        countConn := Connection.().();
        while countConn > 1 do
        begin
          //     30   
          Sleep(30000);
          countConn := Connection.().();
        end;
      end else
      begin
        //  
        WriteLog(i, '    ', ' !' + #13#10 + '    ' + #13#10 + ' : ' + IntToStr(countConn-1), True);
        Error := True;
        Exit;
      end;
    end
  end;
end;

//*****************************************************************************//
//    
procedure StartExchangeBackground;
var
  i, l, DownLog: Word;
  ErrString: String[255];
  countExchange: Byte; //     
  FS: TFileStream; //       
  LogPath: String;
  LogSize: Int64;
  Error: Boolean;
  TempLog: TextFile;
begin
  try
    countExchange := 0;
    //     
    if not FileExists(MainData.RunPath) then
    begin
      WriteLog(51, '   ', ' ' + #13#10 + '   1 ', True);
      Raise Exception.CreateFmt(ErrString, ['']);
    end;

    if MainData.Count = 0 then
    begin
      ErrString := '     !';
      WriteLog(51, '', '  :' + #13#10 + ErrString, True);
      Raise Exception.CreateFmt(ErrString, ['']);
    end;

    // ,      
    for i:=0 to MainData.Count - 1 do
    begin
      if not MainData.Data[i].Exchange then
      begin
        //   
        Continue;
      end;
      Inc(countExchange);
    end;

    if countExchange = 0 then
    begin
      WriteLog(51, '', '  :' + #13#10 + '     !', True);
      Raise Exception.CreateFmt(ErrString, ['']);
    end;

    //     
    if MainData.Ping then
    begin;
      ErrString := CreatePing();
      if ErrString <> '' then
      begin
        WriteLog(51, '   ', ' !' + #13#10 + '    ' + #13#10 + ErrString, True);
        Raise Exception.CreateFmt(ErrString, ['']);
      end;
      //   
      ThreadPing := TThreadPing.Create(True);
      ThreadPing.Resume;
      StartPing := True;
    end;

    //     
    for i:=0 to MainData.Count - 1 do
    begin
      if not MainData.Data[i].Exchange then
      begin
        //   
        Continue;
      end;

      StartSingleExchange(i, Error);

      if NeedUpdate and not Error then
      begin
        //   
        try
          UpdateCfg(MainData.Data[i]);
        except
        on E:Exception do
          begin
            WriteLog(i, '    ', ' !' + #13#10 + E.Message, True);
            Error := True;
          end;
        end;
      end;
      if not Error then
      begin
        //     
        WriteLog(i, MainData.Data[i].Name + '.    !', '    ' + MainData.Data[i].Name + '  !', False);
      end;
    end;

    //     FTP
    try
      LogPath := MainData.LogPath;
      if MainData.SendLogToFTP then
      begin
        FTP := TIdFTP.Create(nil);
        FTP.Host := MainData.FTPServer;
        FTP.Username := MainData.FTPUserName;
        FTP.Password := MainData.FTPUserPassword;
        FTP.Passive := True;
        if FileExists(LogPath) and not Error then
        begin
          FTP.Connect();

          if MainData.FTPDir <> '' then
          begin
            FTP.ChangeDir(MainData.FTPDir);
          end;

          //    
          FTP.Put(LogPath, 'Exchange.log');

          //   
          if MainData.DeleteLog then
          begin
            FS := TFileStream.Create(LogPath, fmOpenRead);
            LogSize := FS.Size;
            FS.Free;
            if LogSize/1024 > MainData.FileLogSize then
            begin
              DeleteFile(PChar(LogPath));
            end;
          end;
        end else
        begin
          if Error then
          begin
            //      FTP   15   
            FTP.Connect();

            if MainData.FTPDir <> '' then
            begin
              FTP.ChangeDir(MainData.FTPDir);
            end;

            //    
            AssignFile(TempLog, Dir+'\RBDExchange.log');
            Rewrite(TempLog);
            if LogsData.Count > 16 then
            begin
              DownLog := LogsData.Count - 16;
            end else
            begin
              DownLog := 0;
            end;

            for l:=DownLog to LogsData.Count-1 do
            begin
              WriteLn(TempLog, LogsData.Data[l].Date + ' ' + LogsData.Data[l].Time + ' ' + LogsData.Data[l].Text + ' ' + LogsData.Data[l].Description);
            end;
            CloseFile(TempLog);

            //   FTP
            FTP.Put(Dir+'\RBDExchange.log', 'RBDExchange.log');

            //    
            DeleteFile(PChar(Dir+'\RBDExchange.log'));
          end;
        end;
      end;
    except
    on E:Exception do
      begin
        ErrString := '      FTP' + #13#10 + E.Message;
        WriteLog(i, '      FTP', ErrString, True);
      end;
    end;
  finally
    //   ,  
    if StartPing then
    begin
      ThreadPing.Terminate;
    end;
  end;
end;

end.
