unit uMain;

interface

uses
  IdFTP,
  IdFTPCommon,
  IdSocks,
  IdTCPConnection,
  IdTCPClient,
  IdIcmpClient,
  SysUtils,
  Classes,
  ShellAPI,
  Messages;

type

  //  
  Settings = record
    Exchange: Boolean; //  ,   
    Name: String[255]; //  
    DBPath: String[255]; //   
    DBUserName: String[100]; //  
    DBUserPassword: String[50]; //  
    DBType: Byte; //    (0 - , 1-)
    ExchangeCode: String[10]; //   
    //  
    RunAfterExchange: Boolean;
    AfterUserName: String[100];
    AfterUserPassword: String[50];
    //     
    RunExchangeIfRun: Boolean;
    //   
    WaitExchange: Boolean;
    //  
    WaitExchangeBg: Boolean;
  end;

  //    FTP
  SettingsSync = record
    Exchange: Boolean; //   
    Name: String[100]; //  
    //  
    Host: String[30];
    Port: Word;
    User: String[30];
    Password: String[30];
    Passive: Boolean;
    TransferType: String[10];
    //  
    SVersion: String[20];
    SHost: String[30];
    SPort: Word;
    SUser: String[30];
    SPassword: String[30];
    //   
    LocalInbox: String[255];
    LocalOutbox: String[255];
    LocalMask: String[50];
    RemoteInbox: String[255];
    RemoteOutbox: String[255];
    RemoteMask: String[50];
    //  
    LockExt: String[3];
    UnlockWait: Integer;
  end;

  //  
  CollectionSettings = record
    //  
    Password: String[50]; //     
    RunPath: String[255]; //   1 
    LogPath: String[255]; //     
    FTPServer: String[100]; //  FTP
    FTPUserName: String[50]; //   FTP
    FTPUserPassword: String[50]; //  FTP
    FTPDir: String[50]; //  FTP
    PingHost: String[100]; //   
    //   
    Data: Array[0..14] of Settings; //    
    //    FTP
    DataSync: Array[0..14] of SettingsSync;
    //  
    DeleteLog: Boolean;
    SendLogToFTP: Boolean;
    Ping: Boolean;
    CloseAfterExchange: Boolean;
    ConnectAdd: Boolean; //       
    InteractiveSync: Boolean; //    FTP     
    //  
    Count: Byte; //  
    CountSync: Byte; //    FTP
    FileLogSize: Integer;
    TrayOnClose: Boolean; //   
    TrayOnStart: Boolean; //   
    StartWithWindows: Boolean; //    Windows
    //  
    shTrue: Boolean; //  
    //  
    shDays: Array[0..6] of Boolean;
    shStartData: TDateTime; //  
    shEndData: TDateTime; //  
    shStartTime: TDateTime; //  
    shEndTime: TDateTime; //  
    shInterval: Byte; // 
    //  
    shTrueSync: Boolean; //  
    //  
    shDaysSync: Array[0..6] of Boolean;
    shStartDataSync: TDateTime; //  
    shEndDataSync: TDateTime; //  
    shStartTimeSync: TDateTime; //  
    shEndTimeSync: TDateTime; //  
    shIntervalSync: Byte; // 
  end;

  //     
  LogSet = record
    Date: String[10]; //  
    Time: String[10]; //  
    Text: String[255]; //  
    Description: String[255]; //  
    Setting: Byte; //  , 51- , 0..49 -      
    Error: Boolean; //  
  end;

  CollectionLogs = record
    Data: Array[0..2999] of LogSet;
    Count: Word; //  
  end;

  TTypeAction = Set of (Sync, FTPConnect, BaseConnect, Exchange);

  procedure SaveSettingsDB();
  procedure ReadSettingsDB();
  procedure OpenProgress();
  procedure ShowProgress(Txt: String);
  procedure CloseProgress();
  function CreateFTPConnection(): String;
  procedure ReadLogs();
  procedure SaveLogs();
  procedure WriteLog(ConfId: Byte; Txt: String; Desc: String; Error: Boolean);
  procedure ShowTextMain(Txt: String);
  function CreatePing(): String;
  function StrRefresh(Str: String; Simb: String): TStringList;
  procedure TraySet(Action: Word; TextTip: String);

  var
  // ,  
  MainData: CollectionSettings;
  // ,   
  LogsData: CollectionLogs;
  Dir: String; //  
  ExeName: String; //  
  FTP: TIdFTP;
  PNG: TIdIcmpClient;
  Background: Boolean;
  IconHandle: THandle; //   
  IconInTray: Boolean; //  ,     
  LastTrayTip: String; //    

implementation

uses
  ufrmMain,
  ufrmProgress;


//***************************************************************************
//     
procedure TraySet(Action: Word; TextTip: String);
var IconData: TNotifyIconData;
begin
  //   
  with IconData do
  begin
    //   
    cbSize := SizeOf(IconData); //  
    Wnd := frmMain.Handle; //  
    uID := 1; //  
    uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP; // 
    uCallbackMessage := WM_USER+121; //  ,    
    hIcon := IconHandle; //  
    if TextTip = '' then
    begin
      if LastTrayTip <> '' then
        TextTip := LastTrayTip
      else
        TextTip := 'RBD Exchange';
    end;
    StrPCopy(szTip, TextTip); //   

    case Action of
      1: begin
          Shell_NotifyIcon(NIM_ADD, @IconData);
          IconInTray := True;
         end;
      2: begin
          Shell_NotifyIcon(NIM_DELETE, @IconData);
          IconInTray := False;
         end;
      3: Shell_NotifyIcon(NIM_MODIFY, @IconData);
    end;

  end;
end;

//*****************************************************************************//
//       
procedure SaveSettingsDB();
var
  SettingsFile: file of CollectionSettings;
begin
  //  MainData  
  AssignFile(SettingsFile, Dir + '\Settings.dat');
  Rewrite(SettingsFile);
  Write(SettingsFile, MainData);
  CloseFile(SettingsFile);
end;

//*****************************************************************************//
//      
procedure ReadSettingsDB();
var
  SettingsFile: file of CollectionSettings;
begin
  //    
  try
    AssignFile(SettingsFile, Dir + '\Settings.dat');
    Reset(SettingsFile);
    Read(SettingsFile, MainData);
    CloseFile(SettingsFile);
  except
    MainData.Count := 0;
    MainData.CountSync := 0;
  end;
end;

//*****************************************************************************//
//     
procedure SaveLogs();
var
  LogsFile: file of CollectionLogs;
begin
  AssignFile(LogsFile, Dir + '\Logs.dat');
  Rewrite(LogsFile);
  Write(LogsFile, LogsData);
  CloseFile(LogsFile);
end;

//*****************************************************************************//
//      
procedure ReadLogs();
var
  LogFile: file of CollectionLogs;
begin
  //    
  try
    AssignFile(LogFile, Dir + '\Logs.dat');
    Reset(LogFile);
    Read(LogFile, LogsData);
    CloseFile(LogFile);
  except
    LogsData.Count:=0;
  end;
end;

//******************************************************************************
//       
function StrRefresh(Str: String; Simb: String): TStringList;
var
  i: Integer;
  CopyStr: String;
begin
  Result := TStringList.Create;
  Str := Trim(Str);
  repeat
    i := Pos(Simb, Str);
    CopyStr := Copy(Str, 1, i-1);
    if CopyStr <> '' then
      Result.Add(CopyStr);
    Str := Trim(Copy(Str, i+1, Length(Str)-i));
  until
    i = 0;
  if (Str <> '') then
    Result.Add(Str);
end;

//*****************************************************************************//
//   FTP 
function CreateFTPConnection(): String;
var
  DirFTP: TStringList;
  i: Integer;
begin
  Result := '';
  try
    try
      FTP := TIdFTP.Create(nil);
      FTP.Host := MainData.FTPServer;
      FTP.Username := MainData.FTPUserName;
      FTP.Password := MainData.FTPUserPassword;
      FTP.Passive := True;
      FTP.Connect();

      //   
      DirFTP := StrRefresh(MainData.FTPDir, '\');
      for i:=0 to DirFTP.Count-1 do
      begin
        FTP.ChangeDir(DirFTP[i]);
      end;
    except
    on E:Exception do
      Result := E.Message;
    end;
  finally
    FTP.Free();
  end;
end;

//*****************************************************************************//
//      
function CreatePing(): String;
begin
  Result := '';
  try
    try
      PNG := TIdIcmpClient.Create(nil);
      PNG.Host := MainData.PingHost;
      PNG.Ping();
    except
    on E:Exception do
      Result := E.Message;
    end;
  finally
    PNG.Free();
  end;
end;

//*****************************************************************************//
//    
procedure OpenProgress();
begin
  frmProgress.Show();
end;

//*****************************************************************************//
//    
procedure CloseProgress();
begin
  frmProgress.Close();
end;

//*****************************************************************************//
//      
procedure ShowProgress(Txt: String);
begin
  frmProgress.txtProgress.Caption := Txt;
  frmProgress.Refresh();
end;

//*****************************************************************************//
//      
procedure ShowTextMain(Txt: String);
begin
  frmMain.txtProgress.Caption := Txt;
end;

//*****************************************************************************//
//     
procedure WriteLog(ConfId: Byte; Txt: String; Desc: String; Error: Boolean);
begin
  if LogsData.Count = 3000 then
    //   
    LogsData.Count:=0;
  LogsData.Data[LogsData.Count].Date := DateToStr(Date);
  LogsData.Data[LogsData.Count].Time := TimeToStr(Time);
  LogsData.Data[LogsData.Count].Setting := ConfId;
  LogsData.Data[LogsData.Count].Text := Txt;
  LogsData.Data[LogsData.Count].Description := Desc;
  LogsData.Data[LogsData.Count].Error := Error;
  Inc(LogsData.Count);
  SaveLogs();
end;

end.
