unit uThreadUpdateProgress;

interface

uses
  Classes, SysUtils, SyncObjs;

type
  TUpdateProgress = class(TThread)
  private
    Progress: byte;
    Visible: Boolean;
  protected
    procedure Execute; override;
    procedure Update;
    procedure SetVisible;
  end;

var
  UpdateProgress: TUpdateProgress;
  CriticalUpdate: TCriticalSection;
  TerminatedProgress: Boolean;

implementation

uses
  ufrmMain;

procedure TUpdateProgress.Update;
begin
  frmMain.ProgressBar.Position := Progress;
end;

procedure TUpdateProgress.SetVisible;
begin
  frmMain.ProgressBar.Visible := Visible;
end;

procedure TUpdateProgress.Execute;
begin
  CriticalUpdate.Enter;
  Visible := True;
  Synchronize(SetVisible);
  progress := 0;
  while (progress < 101) and (not TerminatedProgress) do
  begin
   Sleep(25);
   Inc(Progress);
   Synchronize(Update);
   if Progress = 100 then
   begin
     Progress := 0;
   end;
  end;
  Progress := 0;
  Synchronize(Update);
  CriticalUpdate.Leave;
  Visible := False;
  Synchronize(SetVisible);
end;

end.
