unit ufrmLogs;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, uMain, ufrmDescription, StdCtrls, Menus, Buttons;

type
  TfrmLogs = class(TForm)
    ListLogs: TListView;
    cmbFilter: TComboBox;
    txtFilter: TLabel;
    PopupMenuLogs: TPopupMenu;
    pmFullDescription: TMenuItem;
    pmClear: TMenuItem;
    btRefresh: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure ListLogsDblClick(Sender: TObject);
    procedure pmFullDescriptionClick(Sender: TObject);
    procedure pmClearClick(Sender: TObject);
    procedure cmbFilterChange(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure btRefreshClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmLogs: TfrmLogs;

implementation

{$R *.dfm}


//****************************************************************************//
//       
procedure LoadLogsToForm();
var
  i: Integer;
  SingleList: TListItem;
  numF: Byte; //  
  Filter: Byte; //    
begin
  //   
  numF := frmLogs.cmbFilter.ItemIndex;
  if numF <> 0 then
  begin
    if numF = 1 then
      //  
      Filter := 51
    else if numF = 2 then
      Filter := 52
    else
      Filter := numF - 2;
  end;
  //     
  frmLogs.ListLogs.Items.Clear();
  for i:=0 to LogsData.Count - 1 do
  begin

    // 
    if numF <> 0 then
    begin
      if Filter <> LogsData.Data[i].Setting then
        // 
        Continue;
    end;

    SingleList := frmLogs.ListLogs.Items.Add();
    SingleList.Caption := LogsData.Data[i].Date;
    SingleList.SubItems.Add(LogsData.Data[i].Time);
    if LogsData.Data[i].Error then
      SingleList.SubItems.Add('!')
    else
      SingleList.SubItems.Add('');
    SingleList.SubItems.Add(LogsData.Data[i].Text);
    SingleList.SubItems.Add(IntToStr(LogsData.Data[i].Setting));
    SingleList.SubItems.Add(LogsData.Data[i].Description);
  end;
end;


//******************************************************************************//
//   
//   
procedure TfrmLogs.FormShow(Sender: TObject);
var
  i: Integer;
begin
  //   
  cmbFilter.Items.Clear();
  cmbFilter.Items.Add(' ');
  cmbFilter.Items.Add(' ');
  cmbFilter.Items.Add('  FTP');
  for i:= 0 to MainData.Count - 1 do
  begin
    cmbFilter.Items.Add(MainData.Data[i].Name);
  end;
  cmbFilter.ItemIndex := 0;
  //   
  LoadLogsToForm();
  //    
  if LogsData.Count > 0 then
  begin
    ListLogs.ItemIndex := LogsData.Count - 1;
    ListLogs.ItemFocused := ListLogs.Items[ListLogs.ItemIndex];
    ListLogs.ItemFocused.MakeVisible(True);
  end;
end;

//******************************************************************************//
//      
procedure TfrmLogs.ListLogsDblClick(Sender: TObject);
begin
  //   
  if ListLogs.Selected <> nil then
  begin
    frmDescription.txtDescription.Lines.Clear();
    frmDescription.txtDescription.Lines.Add(ListLogs.Selected.Caption + ' ' + ListLogs.Selected.SubItems[0]);
    frmDescription.txtDescription.Lines.Add(ListLogs.Selected.SubItems[4]);
    frmDescription.ShowModal();
  end;
end;

//******************************************************************************//
//      " "
procedure TfrmLogs.pmFullDescriptionClick(Sender: TObject);
begin
  if ListLogs.Selected <> nil then
  begin
    frmDescription.txtDescription.Lines.Clear();
    frmDescription.txtDescription.Lines.Add(ListLogs.Selected.Caption + ' ' + ListLogs.Selected.SubItems[0]);
    frmDescription.txtDescription.Lines.Add(ListLogs.Selected.SubItems[4]);
    frmDescription.ShowModal();
  end;
end;

//******************************************************************************//
//      " "
procedure TfrmLogs.pmClearClick(Sender: TObject);
begin
  if LogsData.Count = 0 then
    MessageBox(Handle, '   ', 'RBD Exchange', MB_OK+MB_ICONASTERISK)
  else
  begin
    if MessageBox(Handle, '   ?', 'RBD Exchange', MB_YESNO+MB_ICONQUESTION) = 6 then
    begin
      LogsData.Count := 0;
      FormShow(Sender);
    end;
  end;
end;

//******************************************************************************//
//    
procedure TfrmLogs.cmbFilterChange(Sender: TObject);
begin
  LoadLogsToForm();
end;

//******************************************************************************//
//    
procedure TfrmLogs.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then
    // ESC
    Close();
end;

//******************************************************************************//
//  
procedure TfrmLogs.btRefreshClick(Sender: TObject);
begin
  LoadLogsToForm();
end;

end.
