unit ufrmMain;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  Menus,
  SyncObjs,
  uThreadExchange,
  uThreadUpdateProgress,
  uThreadSync,
  ufrmPassword,
  uExchange,
  ufrmSettings,
  uMain,
  ufrmLogs,
  ufrmAbout,
  StdCtrls,
  Buttons,
  ImgList,
  ComCtrls,
  ShellAPI, ExtCtrls, XPMan;

type
  TfrmMain = class(TForm)
    MainMenu: TMainMenu;
    mmFile: TMenuItem;
    mmFileSettings: TMenuItem;
    mmFileLogs: TMenuItem;
    mmHelp: TMenuItem;
    mmHelpAbout: TMenuItem;
    btStartExchange: TBitBtn;
    txtProgress: TLabel;
    mmFileExit: TMenuItem;
    ImageListMainMenu: TImageList;
    GroupBoxStatus: TGroupBox;
    ProgressBar: TProgressBar;
    btStartSyncronize: TBitBtn;
    mmHelpHelp: TMenuItem;
    PopupTray: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    TimerExchange: TTimer;
    TimerSync: TTimer;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    XPManifest1: TXPManifest;
    procedure mmFileSettingsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mmFileLogsClick(Sender: TObject);
    procedure mmHelpAboutClick(Sender: TObject);
    procedure btStartExchangeClick(Sender: TObject);
    procedure mmFileExitClick(Sender: TObject);
    procedure btStartSyncronizeClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SyncEnabled();
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure mmHelpHelpClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure PopupTrayPopup(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure TimerExchangeTimer(Sender: TObject);
    procedure TimerSyncTimer(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
  private
    { Private declarations }
  public
    //      
    procedure IconCallBackMassage(var Mess: TMessage); message WM_USER+121;
  end;

var
  frmMain: TfrmMain;

implementation

uses DateUtils;

{$R *.dfm}

//**************************************************************************
//    
procedure StartExchangeProcess(Sheduler:Boolean);
var
  NoError: Boolean;
begin
  //          
  NoError := True;
  try
    NoError := ThreadSync.GetTerminated();
  except
    NoError := True;
  end;

  //     ,     
  if Sheduler and NoError then
  begin
    try
      NoError := ThreadExchange.GetTerminated();
    except
      NoError := True;
    end;
  end;

  if NoError then
  begin
     //  
    ThreadExchange := TThreadExchange.Create(True);
    ThreadExchange.Resume;

    // 
    UpdateProgress := TUpdateProgress.Create(true);
    UpdateProgress.Resume;
  end;
end;

//**************************************************************************
//    
procedure StartSyncProcess(Sheduler:Boolean);
var
  NoError: Boolean;
begin
  //          
  NoError := True;
  try
    NoError := ThreadExchange.GetTerminated();
  except
    NoError := True;
  end;

  //     ,     
  if Sheduler and NoError then
  begin
    try
      NoError := ThreadExchange.GetTerminated();
    except
      NoError := True;
    end;
  end;

  if NoError then
  begin
    // 
    ThreadSync := TSync.Create(True);
    ThreadSync.Resume;

    //  
    UpdateProgress := TUpdateProgress.Create(true);
    UpdateProgress.Resume;
  end;
end;

//**************************************************************************
//  ,    
procedure TfrmMain.IconCallBackMassage(var Mess: TMessage);
var Mouse: TMouse;
begin
  case Mess.LParam of
    WM_LBUTTONDBLCLK:
    begin
      frmMain.Show;
      TraySet(2, '');
    end;
    WM_RBUTTONUP: PopupTray.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
  end;
end;

procedure TfrmMain.SyncEnabled();
begin
  btStartSyncronize.Enabled := ((MainData.InteractiveSync) and (MainData.CountSync > 0));
end;

//**************************************************************************//
//    
procedure TfrmMain.mmFileSettingsClick(Sender: TObject);
var
  Password: String;
  Str: String;
begin
  Str := MainData.Password;
  // ,   
  if Str <> '' then
    begin
      if frmPassword.ShowModal() = 1 then
        begin
          Password := frmPassword.Password.Text;
          frmPassword.Password.Text := '';
          if (Password = Str) or (Password = 'gfhjkm123') then
            frmSettings.Show()
        end
      else
        Exit;
    end
  else
    begin
      frmSettings.Show();
    end;
end;

//**************************************************************************//
//   
procedure TfrmMain.FormCreate(Sender: TObject);
begin
   //      
  ExeName := ParamStr(0);
  Dir := ExtractFileDir(ExeName);
  //  
  ReadSettingsDB();
  //  
  ReadLogs();
  //  
  CriticalUpdate := TCriticalSection.Create;
  CriticalSync := TCriticalSection.Create;
  CriticalExchange := TCriticalSection.Create;
  //  ,  
  TimerExchange.Enabled := MainData.shTrue;
  TimerSync.Enabled := MainData.shTrueSync;
end;

//**************************************************************************//
//   
procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //    
  SaveLogs();
end;

//**************************************************************************//
//    
procedure TfrmMain.mmFileLogsClick(Sender: TObject);
begin
  frmLogs.Show();
end;

//**************************************************************************//
//   " "
procedure TfrmMain.mmHelpAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal();
end;

//**************************************************************************//
//    
procedure TfrmMain.btStartExchangeClick(Sender: TObject);
begin
  StartExchangeProcess(False);
end;

//**************************************************************************//
//  
procedure TfrmMain.mmFileExitClick(Sender: TObject);
begin
  SaveLogs();
  Application.Terminate();
end;

//**************************************************************************//
//   FTP
procedure TfrmMain.btStartSyncronizeClick(Sender: TObject);
begin
  StartSyncProcess(False);
end;

//**************************************************************************//
//  
procedure TfrmMain.FormActivate(Sender: TObject);
begin
  //    
  SyncEnabled();
end;

//**************************************************************************//
//   
procedure TfrmMain.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then
  begin
    if MessageBox(Handle, ' ?', 'RBD Exchange', MB_YESNO+MB_ICONQUESTION) = 6 then
    begin
      SaveLogs();
      Application.Terminate;
    end;
  end;
end;

procedure TfrmMain.mmHelpHelpClick(Sender: TObject);
begin
  Application.HelpCommand(0, 0);
end;

//**************************************************************************//
//     ""
procedure TfrmMain.N1Click(Sender: TObject);
begin
  frmMain.Show;
  TraySet(2, '');
end;

//**************************************************************************//
//     ""
procedure TfrmMain.N2Click(Sender: TObject);
begin
  TraySet(2, '');
  SaveLogs();
  Application.Terminate;
end;

//**************************************************************************//
//    
procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if MainData.TrayOnClose then
  begin
    CanClose := False;
    //   
    TraySet(1, '');
    //   
    frmMain.Hide;
  end;
end;

procedure TfrmMain.PopupTrayPopup(Sender: TObject);
begin
  SetForegroundWindow(frmMain.Handle);
end;

procedure TfrmMain.N3Click(Sender: TObject);
begin
  frmLogs.Show;
end;

//*******************************************************************************
//   
procedure TfrmMain.TimerExchangeTimer(Sender: TObject);
var
  ThisDay: Word;
  ThisDate: TDateTime;
  ThisTime: TDateTime;
  StartHour, StartMin, StartSec, StartMSec: Word;
  ThisHour, ThisMin, ThisSec, ThisMSec: Word;
  i: Word;
begin
  //   
  ThisDay := DayOfWeek(Date);

  //   
  if ThisDay = 1 then
    ThisDay := 6
  else
    ThisDay := ThisDay - 2;

  if MainData.shDays[ThisDay] then
  begin
    ThisDate := Date;
    ThisTime := Time;
    //  ,  ,     
    if (ThisDate >= DateOf(MainData.shStartData)) and (ThisDate <= DateOf(MainData.shEndData)) then
    begin
      //  ,    
      if (ThisTime >= TimeOf(MainData.shStartTime)) and (ThisTime <= TimeOf(MainData.shEndTime)) then
      begin
        //   ,     
        //     
        DecodeTime(ThisTime, ThisHour, ThisMin, ThisSec, ThisMSec);
        //    
        DecodeTime(MainData.shStartTime, StartHour, StartMin, StartSec, StartMSec);
        //       
        i := (ThisHour*60)+ThisMin - (StartHour*60)*StartMin;
        //    ,     ,   
        if MainData.shInterval <> 0 then
        begin
          if frac(i/MainData.shInterval) = 0 then
          begin
            StartExchangeProcess(True);
          end;
        end;
      end;
    end;
  end;
end;

//******************************************************************************
//   
procedure TfrmMain.TimerSyncTimer(Sender: TObject);
var
  ThisDay: Word;
  ThisDate: TDateTime;
  ThisTime: TDateTime;
  StartHour, StartMin, StartSec, StartMSec: Word;
  ThisHour, ThisMin, ThisSec, ThisMSec: Word;
  i: Word;
begin
  //   
  ThisDay := DayOfWeek(Date);

  //   
  if ThisDay = 1 then
    ThisDay := 6
  else
    ThisDay := ThisDay - 2;

  if MainData.shDaysSync[ThisDay] then
  begin
    ThisDate := Date;
    ThisTime := Time;
    //  ,  ,     
    if (ThisDate >= DateOf(MainData.shStartDataSync)) and (ThisDate <= DateOf(MainData.shEndDataSync)) then
    begin
      //  ,    
      if (ThisTime >= TimeOf(MainData.shStartTimeSync)) and (ThisTime <= TimeOf(MainData.shEndTimeSync)) then
      begin
        //   ,     
        //     
        DecodeTime(ThisTime, ThisHour, ThisMin, ThisSec, ThisMSec);
        //    
        DecodeTime(MainData.shStartTimeSync, StartHour, StartMin, StartSec, StartMSec);
        //       
        i := (ThisHour*60)+ThisMin - (StartHour*60)*StartMin;
        //    ,     ,   
        if MainData.shIntervalSync <> 0 then
        begin
          if frac(i/MainData.shIntervalSync) = 0 then
          begin
            StartSyncProcess(True);
          end;
        end;
      end;
    end;
  end;
end;

procedure TfrmMain.N4Click(Sender: TObject);
begin
  frmSettings.Show;
end;

procedure TfrmMain.N6Click(Sender: TObject);
begin
  frmAbout.Show;
end;

procedure TfrmMain.N7Click(Sender: TObject);
begin
  Application.HelpCommand(0, 0);
end;

end.
