unit ufrmSettings;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  StdCtrls,
  Buttons,
  ufrmSingleSync,
  ufrmSingleSetting,
  uMain, ExtCtrls, ImgList, Spin, CheckLst, Mask,
  Registry;

type
  TfrmSettings = class(TForm)
    PageControlSettings: TPageControl;
    TabBD: TTabSheet;
    ListSettings: TListView;
    btAdd: TBitBtn;
    btEdit: TBitBtn;
    btClose: TBitBtn;
    btSave: TBitBtn;
    TabOtherSetting: TTabSheet;
    EditPath1C: TLabeledEdit;
    OpenDialog: TOpenDialog;
    btDel: TBitBtn;
    GroupBoxParLog: TGroupBox;
    EditLogPath: TLabeledEdit;
    btOpenLogPath: TButton;
    cbSendFileLogToFTP: TCheckBox;
    GroupBoxParFTP: TGroupBox;
    EditFTPServer: TLabeledEdit;
    EditFTPUserName: TLabeledEdit;
    EditFTPUserPassword: TLabeledEdit;
    EditFTPDir: TLabeledEdit;
    cbDeleteLogFile: TCheckBox;
    LabelSizeDelLog: TLabel;
    btRefreshFTP: TBitBtn;
    cbPing: TCheckBox;
    EditPingHost: TLabeledEdit;
    cbCloseAfterExchange: TCheckBox;
    ImageListPages: TImageList;
    ImageListForListSettings: TImageList;
    cbConnectAdd: TCheckBox;
    EditPassword: TLabeledEdit;
    TabSyncSettings: TTabSheet;
    ListSync: TListView;
    btAddSync: TBitBtn;
    btEditSync: TBitBtn;
    btDeleteSync: TBitBtn;
    btOpenPath1C: TBitBtn;
    EditFileLogSize: TSpinEdit;
    cbEditInteractiveSync: TCheckBox;
    cbTrayOnClose: TCheckBox;
    cbTrayOnStart: TCheckBox;
    TabSheduler: TTabSheet;
    CheckListSh: TCheckListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    DateEnd: TDateTimePicker;
    DateStart: TDateTimePicker;
    TimeStart: TDateTimePicker;
    Label4: TLabel;
    TimeEnd: TDateTimePicker;
    Label5: TLabel;
    shInterval: TSpinEdit;
    Label6: TLabel;
    Label7: TLabel;
    cbshTrue: TCheckBox;
    cbshTrueSync: TCheckBox;
    CheckListShSync: TCheckListBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    shIntervalSync: TSpinEdit;
    Label11: TLabel;
    DateEndSync: TDateTimePicker;
    DateStartSync: TDateTimePicker;
    Label12: TLabel;
    Label13: TLabel;
    TimeEndSync: TDateTimePicker;
    Label14: TLabel;
    GroupBoxSh: TGroupBox;
    GroupBoxShSync: TGroupBox;
    cbStartWithWindows: TCheckBox;
    TimeStartSync: TDateTimePicker;
    procedure btAddClick(Sender: TObject);
    procedure btEditClick(Sender: TObject);
    procedure btCloseCick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListSettingsDblClick(Sender: TObject);
    procedure EditPath1CChange(Sender: TObject);
    procedure btDelClick(Sender: TObject);
    procedure btOpenLogPathClick(Sender: TObject);
    procedure cbSendFileLogToFTPClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure EditFTPServerChange(Sender: TObject);
    procedure EditFTPUserNameChange(Sender: TObject);
    procedure EditFTPUserPasswordChange(Sender: TObject);
    procedure EditFTPDirChange(Sender: TObject);
    procedure cbDeleteLogFileClick(Sender: TObject);
    procedure EditFileLogSizeChange(Sender: TObject);
    procedure btRefreshFTPClick(Sender: TObject);
    procedure cbPingClick(Sender: TObject);
    procedure EditPingHostChange(Sender: TObject);
    procedure cbCloseAfterExchangeClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure cbConnectAddClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditPasswordChange(Sender: TObject);
    procedure btAddSyncClick(Sender: TObject);
    procedure btOpenPath1CClick(Sender: TObject);
    procedure LoadSyncToForm();
    procedure LoadSettingsToForm();
    procedure btEditSyncClick(Sender: TObject);
    procedure EditSyncSetting();
    procedure ListSyncDblClick(Sender: TObject);
    procedure btDeleteSyncClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure cbEditInteractiveSyncClick(Sender: TObject);
    procedure cbTrayOnCloseClick(Sender: TObject);
    procedure cbTrayOnStartClick(Sender: TObject);
    procedure shIntervalChange(Sender: TObject);
    procedure DateStartChange(Sender: TObject);
    procedure DateEndChange(Sender: TObject);
    procedure TimeStartChange(Sender: TObject);
    procedure TimeEndChange(Sender: TObject);
    procedure cbshTrueClick(Sender: TObject);
    procedure DateStartSyncChange(Sender: TObject);
    procedure DateEndSyncChange(Sender: TObject);
    procedure TimeStartSyncChange(Sender: TObject);
    procedure TimeEndSyncChange(Sender: TObject);
    procedure shIntervalSyncChange(Sender: TObject);
    procedure cbshTrueSyncClick(Sender: TObject);
    procedure cbStartWithWindowsClick(Sender: TObject);
    procedure CheckListShClickCheck(Sender: TObject);
    procedure CheckListShSyncClickCheck(Sender: TObject);
    procedure SaveFormsParams(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSettings: TfrmSettings;
  Edited: Boolean;

implementation

uses
  ufrmMain;

{$R *.dfm}

procedure TfrmSettings.SaveFormsParams(Sender: TObject);
var i: Byte;
  Reg: TRegIniFile;
begin
  MainData.RunPath:=EditPath1C.Text;

  //  
  for i:=0 to CheckListSh.Items.Count-1 do
  begin
    MainData.shDays[i] := CheckListSh.Checked[i];
  end;
  //  
  for i:=0 to CheckListShSync.Items.Count-1 do
  begin
    MainData.shDaysSync[i] := CheckListShSync.Checked[i];
  end;
  MainData.shInterval := shInterval.Value;
  MainData.shIntervalSync := shIntervalSync.Value;

  SaveSettingsDB();
  Edited := False;

  //   ,   
  frmMain.TimerExchange.Enabled := MainData.shTrue;
  frmMain.TimerSync.Enabled := MainData.shTrueSync;

  //    
  try
    try
      Reg := TRegIniFile.Create('Software');
      Reg.OpenKey('Microsoft', false);
      Reg.OpenKey('Windows', false);
      Reg.OpenKey('CurrentVersion', false);
      if MainData.StartWithWindows then
        Reg.WriteString('Run', 'RBDExchange', ExeName)
      else
        Reg.DeleteKey('Run', 'RBDExchange');
    except
      ShowMessage('   "   Windows"!');
    end;
  finally
    Reg.Free();
  end;
end;

//****************************************************************************//
//       
procedure VisibleSet();
begin
  //   
  frmSettings.EditLogPath.Enabled := frmSettings.cbSendFileLogToFTP.Checked;
  frmSettings.btOpenLogPath.Enabled := frmSettings.cbSendFileLogToFTP.Checked;

  frmSettings.GroupBoxParFTP.Enabled := frmSettings.cbSendFileLogToFTP.Checked;
  frmSettings.EditFTPServer.Enabled := frmSettings.GroupBoxParFTP.Enabled;
  frmSettings.EditFTPUserName.Enabled := frmSettings.GroupBoxParFTP.Enabled;
  frmSettings.EditFTPUserPassword.Enabled := frmSettings.GroupBoxParFTP.Enabled;
  frmSettings.EditFTPDir.Enabled := frmSettings.GroupBoxParFTP.Enabled;
  frmSettings.btRefreshFTP.Enabled := frmSettings.GroupBoxParFTP.Enabled;

  frmSettings.EditFileLogSize.Enabled := frmSettings.cbDeleteLogFile.Checked;

  //  
  frmSettings.EditPingHost.Enabled := frmSettings.cbPing.Checked;

  //  
  frmSettings.CheckListSh.Enabled := frmSettings.cbshTrue.Checked;
  frmSettings.DateStart.Enabled := frmSettings.cbshTrue.Checked;
  frmSettings.DateEnd.Enabled := frmSettings.cbshTrue.Checked;
  frmSettings.TimeStart.Enabled := frmSettings.cbshTrue.Checked;
  frmSettings.TimeEnd.Enabled := frmSettings.cbshTrue.Checked;
  frmSettings.shInterval.Enabled := frmSettings.cbshTrue.Checked;

  //  
  frmSettings.CheckListShSync.Enabled := frmSettings.cbshTrueSync.Checked;
  frmSettings.DateStartSync.Enabled := frmSettings.cbshTrueSync.Checked;
  frmSettings.DateEndSync.Enabled := frmSettings.cbshTrueSync.Checked;
  frmSettings.TimeStartSync.Enabled := frmSettings.cbshTrueSync.Checked;
  frmSettings.TimeEndSync.Enabled := frmSettings.cbshTrueSync.Checked;
  frmSettings.shIntervalSync.Enabled := frmSettings.cbshTrueSync.Checked;
end;

//****************************************************************************//
//     
procedure ClearSetting(var RecordSet: Settings);
begin
  SingleSetting.Exchange := True;
  SingleSetting.Name:='';
  SingleSetting.DBType:=0;
  SingleSetting.DBPath:='';
  SingleSetting.DBUserName:='';
  SingleSetting.DBUserPassword:='';
  SingleSetting.ExchangeCode:='';

  SingleSetting.RunAfterExchange := False;
  SingleSetting.AfterUserName := '';
  SingleSetting.AfterUserPassword := '';

  SingleSetting.RunExchangeIfRun := False;
  SingleSetting.WaitExchange := False;
  SingleSetting.WaitExchangeBg := True;
end;

//****************************************************************************//
//      
procedure ClearSettingSync(var RecordSync: SettingsSync);
begin
  RecordSync.Name := '';
  RecordSync.Host := '';
  RecordSync.User := '';
  RecordSync.Password := '';
  RecordSync.Port := 21;
  RecordSync.LocalInbox := '';
  RecordSync.LocalOutbox := '';
  RecordSync.LocalMask := '*.*';
  RecordSync.RemoteInbox := '';
  RecordSync.RemoteOutbox := '';
  RecordSync.RemoteMask := '*.*';
  RecordSync.SHost := '';
  RecordSync.SPort := 0;
  RecordSync.SUser := '';
  RecordSync.SPassword := '';
  RecordSync.LockExt := 'lck';
  RecordSync.UnlockWait := 30;
  RecordSync.TransferType := 'Binary';
  RecordSync.SVersion := ' ';
  RecordSync.Passive := True;
  RecordSync.Exchange := True;
end;

//****************************************************************************//
//      
procedure EditSingleSetting(ListSettings: TListView);
begin
  if ListSettings.Selected = nil then exit;
  begin

    SingleSetting := MainData.Data[ListSettings.ItemIndex];

    //   
    frmSingleSetting.Caption:=' ';
    if frmSingleSetting.ShowModal() = 1 then
    begin

      //   
      MainData.Data[ListSettings.ItemIndex] := SingleSetting;

      //    
      frmSettings.LoadSettingsToForm();

      //  
      WriteLog(51, '  ', ' : ' + #13#10 + SingleSetting.Name, False);

      Edited := True;
    end;
  end;
  ClearSetting(SingleSetting);
end;


//****************************************************************************//

//     
procedure TfrmSettings.btAddClick(Sender: TObject);
var
  Description: String;
begin
  ClearSetting(SingleSetting);
  if not FileExists(MainData.RunPath) then
  begin
    MessageBox(Handle,'     1 !', '', MB_OK+MB_ICONASTERISK);
    Exit;
  end;
  //   
  frmSingleSetting.Caption:=' ';
  if frmSingleSetting.ShowModal() = 1 then
  begin
    //    
    MainData.Data[MainData.Count] := SingleSetting;
    Inc(MainData.Count);

    //  
    LoadSettingsToForm();

        //  
    Description := ': ' + SingleSetting.Name + #13#10 + '  : ' + SingleSetting.DBPath;
    WriteLog(51, '   ', Description, False);

    ClearSetting(SingleSetting);

    Edited := True;
  end;
end;

//****************************************************************************//
//     
procedure TfrmSettings.btEditClick(Sender: TObject);
begin
  EditSingleSetting(ListSettings);
end;


//****************************************************************************//
//   
procedure TfrmSettings.btCloseCick(Sender: TObject);
begin
  if not Edited then
    ReadSettingsDB();
  Close();
end;


//****************************************************************************//
//     
procedure TfrmSettings.btSaveClick(Sender: TObject);
begin
  SaveFormsParams(Sender);
  Close();
end;

//****************************************************************************//
//      
procedure TfrmSettings.LoadSyncToForm();
var
  i: Integer;
  ListItem: TListItem;
begin
  //  
  ListSync.Items.Clear();
  //  
  for i := 0 to MainData.CountSync - 1 do
  begin
    ListItem := ListSync.Items.Add();
    ListItem.ImageIndex := -1;
    ListItem.Caption := IntToStr(i+1);
    ListItem.SubItems.Add('');

    if MainData.DataSync[i].Exchange then
      ListItem.SubItemImages[0] := 0
    else
      ListItem.SubItemImages[0] := 1;

    ListItem.SubItems.Add(MainData.DataSync[i].Name);
    ListItem.SubItems.Add(MainData.DataSync[i].Host);
    ListItem.SubItems.Add(IntToStr(MainData.DataSync[i].Port));
    ListItem.SubItems.Add(MainData.DataSync[i].User);
  end;
end;

//****************************************************************************//
//      
procedure TfrmSettings.LoadSettingsToForm();
var
  i: Integer;
  ListItem: TListItem;
begin
  //    
  ListSettings.Items.Clear();
  //   
  for i:=0 to MainData.Count - 1 do
  begin
    ListItem:=ListSettings.Items.Add();

    ListItem.Caption:=IntToStr(i+1);
    ListItem.ImageIndex := -1;

    //    
    ListItem.SubItems.Add('');
    if MainData.Data[i].Exchange then
      ListItem.SubItemImages[0] := 0
    else
      ListItem.SubItemImages[0] := 1;

    ListItem.SubItems.Add(MainData.Data[i].Name);
    ListItem.SubItems.Add(MainData.Data[i].DBPath);

    if MainData.Data[i].DBType = 0 then
      ListItem.SubItems.Add('')
    else
      ListItem.SubItems.Add('');

    ListItem.SubItems.Add(MainData.Data[i].DBUserName);
    ListItem.SubItems.Add(MainData.Data[i].DBUserPassword);
    ListItem.SubItems.Add(MainData.Data[i].ExchangeCode);
  end;
end;


//****************************************************************************//
//     
procedure TfrmSettings.EditSyncSetting();
begin
  if ListSync.Selected <> nil then
  begin
    SingleSync := MainData.DataSync[ListSync.ItemIndex];
    if frmSingleSync.ShowModal() = 1 then
    begin
      MainData.DataSync[ListSync.ItemIndex] := SingleSync;
      ClearSettingSync(SingleSync);
      LoadSyncToForm();
      Edited := True;
    end;
  end;
end;

//****************************************************************************//
//     
procedure LoadDaysToList(CheckList: TCheckListBox);
begin
  CheckList.Items.Add('');
  CheckList.Items.Add('');
  CheckList.Items.Add('');
  CheckList.Items.Add('');
  CheckList.Items.Add('');
  CheckList.Items.Add('');
  CheckList.Items.Add('');
end;

//****************************************************************************//
//   
procedure TfrmSettings.FormShow(Sender: TObject);
var
  i: Byte;
begin
  //  
  //   1
  EditPath1C.Text:=MainData.RunPath;
  //  
  EditLogPath.Text := MainData.LogPath;
  // FTP
  EditFTPServer.Text := MainData.FTPServer;
  EditFTPUserName.Text := MainData.FTPUserName;
  EditFTPUserPassword.Text := MainData.FTPUserPassword;
  EditFTPDir.Text := MainData.FTPDir;
  EditFileLogSize.Value := MainData.FileLogSize;
  // 
  EditPingHost.Text := MainData.PingHost;
  // 
  EditPassword.Text := MainData.Password;
  // 
  cbSendFileLogToFTP.Checked := MainData.SendLogToFTP;
  cbDeleteLogFile.Checked := MainData.DeleteLog;
  cbPing.Checked := MainData.Ping;
  cbCloseAfterExchange.Checked := MainData.CloseAfterExchange;
  cbConnectAdd.Checked := MainData.ConnectAdd;
  cbEditInteractiveSync.Checked := MainData.InteractiveSync;
  cbTrayOnClose.Checked := MainData.TrayOnClose;
  cbTrayOnStart.Checked := MainData.TrayOnStart;
  cbStartWithWindows.Checked := MainData.StartWithWindows;
  //    
  LoadSettingsToForm();
  //     FTP
  LoadSyncToForm();
  //  
  cbshTrue.Checked := MainData.shTrue;

  LoadDaysToList(CheckListSh);
  for i:=0 to 6 do
  begin
    CheckListSh.Checked[i] := MainData.shDays[i];
  end;

  DateStart.DateTime := MainData.shStartData;
  DateEnd.DateTime := MainData.shEndData;
  TimeStart.Time := MainData.shStartTime;
  TimeEnd.Time := MainData.shEndTime;

  shInterval.Value := MainData.shInterval;

  //  
  cbshTrueSync.Checked := MainData.shTrueSync;
  LoadDaysToList(CheckListShSync);
  for i:=0 to 6 do
  begin
    CheckListShSync.Checked[i] := MainData.shDaysSync[i];
  end;

  DateStartSync.DateTime := MainData.shStartDataSync;
  DateEndSync.DateTime := MainData.shEndDataSync;
  TimeStartSync.Time := MainData.shStartTimeSync;
  TimeEndSync.Time := MainData.shEndTimeSync;

  shIntervalSync.Value := MainData.shIntervalSync;

  Edited := False;
end;


//****************************************************************************//
//      
procedure TfrmSettings.ListSettingsDblClick(Sender: TObject);
begin
  EditSingleSetting(ListSettings);
end;

//****************************************************************************//
//    
procedure TfrmSettings.EditPath1CChange(Sender: TObject);
begin
  MainData.RunPath:=EditPath1C.Text;
  Edited := True;
end;

//****************************************************************************//
//    
procedure TfrmSettings.btDelClick(Sender: TObject);
begin
  if ListSettings.Selected <> nil then
  begin
    if MessageBox(Handle, '  ?', 'RBD Exchange', MB_YESNO+MB_ICONQUESTION) = 6 then
    begin
      // 
      //  
      ClearSetting(MainData.Data[ListSettings.ItemIndex]);

      Dec(MainData.Count);

      // 
      ListSettings.Items.Delete(ListSettings.ItemIndex);

      Edited := True;
    end;
  end;
end;

//****************************************************************************//
//        
procedure TfrmSettings.btOpenLogPathClick(Sender: TObject);
begin
  OpenDialog.Title := '   ';
  OpenDialog.Filter := ' |*.txt|*.log';
  if OpenDialog.Execute then
  begin
    EditLogPath.Text := OpenDialog.FileName;
    MainData.LogPath := EditLogPath.Text;
    Edited := True;
  end;
end;

//****************************************************************************//
//       FTP 
procedure TfrmSettings.cbSendFileLogToFTPClick(Sender: TObject);
begin
  VisibleSet();
  MainData.SendLogToFTP := cbSendFileLogToFTP.Checked;
  Edited := True;
end;


//****************************************************************************//
//   
procedure TfrmSettings.FormPaint(Sender: TObject);
begin
  VisibleSet();
end;


//****************************************************************************//
//   FTP
procedure TfrmSettings.EditFTPServerChange(Sender: TObject);
begin
  MainData.FTPServer := EditFTPServer.Text;
  Edited := True;
end;

//****************************************************************************//
//    FTP
procedure TfrmSettings.EditFTPUserNameChange(Sender: TObject);
begin
  MainData.FTPUserName := EditFTPUserName.Text;
  Edited := True;
end;

//****************************************************************************//
//   FTP
procedure TfrmSettings.EditFTPUserPasswordChange(Sender: TObject);
begin
  MainData.FTPUserPassword := EditFTPUserPassword.Text;
  Edited := True;
end;

//****************************************************************************//
//   FTP
procedure TfrmSettings.EditFTPDirChange(Sender: TObject);
begin
  MainData.FTPDir := EditFTPDir.Text;
  Edited := True;
end;


//****************************************************************************//
//       
procedure TfrmSettings.cbDeleteLogFileClick(Sender: TObject);
begin
  VisibleSet();
  MainData.DeleteLog := cbDeleteLogFile.Checked;
  Edited := True;
end;

//****************************************************************************//
//      
procedure TfrmSettings.EditFileLogSizeChange(Sender: TObject);
begin
  MainData.FileLogSize := EditFileLogSize.Value;
  Edited := True;
end;

//****************************************************************************//
//   FTP
procedure TfrmSettings.btRefreshFTPClick(Sender: TObject);
var
  ErrString: String;
begin
  OpenProgress();
  ShowProgress('  FTP...');
  ErrString := CreateFTPConnection();
  CloseProgress();
  if ErrString <> '' then
    begin
      WriteLog(51, '   FTP', ErrString, True);
      MessageBox(Handle, PChar(ErrString), '', MB_OK+MB_ICONWARNING);
    end

  else
    MessageBox(Handle, '  ', 'RBD Exchange', MB_OK+MB_ICONASTERISK);

end;

//****************************************************************************//
//  
procedure TfrmSettings.cbPingClick(Sender: TObject);
begin
  MainData.Ping := cbPing.Checked;
  Edited := True;
  VisibleSet();
end;

//****************************************************************************//
//   
procedure TfrmSettings.EditPingHostChange(Sender: TObject);
begin
  MainData.PingHost := EditPingHost.Text;
  Edited := True;
end;

//****************************************************************************//
//    
procedure TfrmSettings.cbCloseAfterExchangeClick(Sender: TObject);
begin
  MainData.CloseAfterExchange := cbCloseAfterExchange.Checked;
  Edited := True;
end;

//****************************************************************************//
//    
procedure TfrmSettings.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then
    // ESC
    Close();
end;

//****************************************************************************//
//      
procedure TfrmSettings.cbConnectAddClick(Sender: TObject);
begin
  MainData.ConnectAdd := cbConnectAdd.Checked;
  Edited := True;
end;

procedure TfrmSettings.FormCreate(Sender: TObject);
begin

end;

//****************************************************************************//
//  
procedure TfrmSettings.EditPasswordChange(Sender: TObject);
begin
  MainData.Password := EditPassword.Text;
  Edited := True;
end;


//****************************************************************************//
//    FTP
procedure TfrmSettings.btAddSyncClick(Sender: TObject);
var
  Description: String[255];
begin
  ClearSettingSync(SingleSync);
  if frmSingleSync.ShowModal() = 1 then
  begin
    //  ,    
    MainData.DataSync[MainData.CountSync] := SingleSync;
    Inc(MainData.CountSync);

    //  
    Description := ': ' + SingleSync.Name + #13#10 + ': ' + SingleSync.Host;
    WriteLog(51, '    FTP', Description, False);

    ClearSettingSync(SingleSync);
    //    
    LoadSyncToForm();
    Edited := True;
  end;
end;

//****************************************************************************//
//     1
procedure TfrmSettings.btOpenPath1CClick(Sender: TObject);
begin
  OpenDialog.Filter:='  1 |1cv8.exe';
  OpenDialog.Title:='   1 ';
  if OpenDialog.Execute then
  begin
    EditPath1C.Text:= OpenDialog.FileName;
    MainData.RunPath:=EditPath1C.Text;
    Edited := True;
  end;
end;

//****************************************************************************//
//        
procedure TfrmSettings.btEditSyncClick(Sender: TObject);
begin
  EditSyncSetting();
end;

//****************************************************************************//
//      
procedure TfrmSettings.ListSyncDblClick(Sender: TObject);
begin
  EditSyncSetting();
end;

//****************************************************************************//
//        
procedure TfrmSettings.btDeleteSyncClick(Sender: TObject);
begin
  if ListSync.Selected <> nil then
  begin
    if MessageBox(Handle, '  ?', 'RBD Exchange', MB_YESNO+MB_ICONQUESTION) = 6 then
    begin
      //   
      ClearSettingSync(MainData.DataSync[ListSync.ItemIndex]);
      //  
      Dec(MainData.CountSync);
      //    
      ListSync.Items.Delete(ListSync.ItemIndex);

      Edited := True;
    end;
  end;
end;

//****************************************************************************//
//   
procedure TfrmSettings.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if Edited then
  begin
    if MessageBox(Handle, '  ?', 'RBD Exchange', MB_YESNO+MB_ICONQUESTION) = 6 then
      SaveFormsParams(Sender)
    else
      ReadSettingsDB();
  end;
end;


//****************************************************************************//
//   "     "
procedure TfrmSettings.cbEditInteractiveSyncClick(Sender: TObject);
begin
  MainData.InteractiveSync := cbEditInteractiveSync.Checked;
  Edited := True;
end;

//****************************************************************************//
//   "    "
procedure TfrmSettings.cbTrayOnCloseClick(Sender: TObject);
begin
  MainData.TrayOnClose := cbTrayOnClose.Checked;
  Edited := True;
end;

//****************************************************************************//
//   "   "
procedure TfrmSettings.cbTrayOnStartClick(Sender: TObject);
begin
  MainData.TrayOnStart := cbTrayOnStart.Checked;
  Edited := True;
end;

//****************************************************************************//
//   
procedure TfrmSettings.shIntervalChange(Sender: TObject);
begin
  MainData.shInterval := shInterval.Value;
end;

//****************************************************************************//
//    
procedure TfrmSettings.DateStartChange(Sender: TObject);
begin
  MainData.shStartData := DateStart.DateTime;
  Edited := True;
end;

//****************************************************************************//
//    
procedure TfrmSettings.DateEndChange(Sender: TObject);
begin
  MainData.shEndData := DateEnd.DateTime;
  Edited := True;
end;

//****************************************************************************//
//    
procedure TfrmSettings.TimeStartChange(Sender: TObject);
begin
  MainData.shStartTime := TimeStart.DateTime;
  Edited := True;
end;

//****************************************************************************//
//    
procedure TfrmSettings.TimeEndChange(Sender: TObject);
begin
  MainData.shEndTime := TimeEnd.DateTime;
  Edited := True;
end;

//****************************************************************************//
//   "   "
procedure TfrmSettings.cbshTrueClick(Sender: TObject);
begin
  MainData.shTrue := cbshTrue.Checked;
  Edited := True;
  VisibleSet();
end;

//****************************************************************************//
//     
procedure TfrmSettings.DateStartSyncChange(Sender: TObject);
begin
  MainData.shStartDataSync := DateStartSync.DateTime;
  Edited := True;
end;

//****************************************************************************//
//     
procedure TfrmSettings.DateEndSyncChange(Sender: TObject);
begin
  MainData.shEndDataSync := DateEndSync.DateTime;
  Edited := True;
end;

//****************************************************************************//
//     
procedure TfrmSettings.TimeStartSyncChange(Sender: TObject);
begin
  MainData.shStartTimeSync := TimeStartSync.DateTime;
  Edited := True;
end;

//****************************************************************************//
//     
procedure TfrmSettings.TimeEndSyncChange(Sender: TObject);
begin
  MainData.shEndTimeSync := TimeEndSync.DateTime;
  Edited := True;
end;

//****************************************************************************//
//    
procedure TfrmSettings.shIntervalSyncChange(Sender: TObject);
begin
  MainData.shIntervalSync := shIntervalSync.Value;
  Edited := True;
end;

//****************************************************************************//
//   "   "
procedure TfrmSettings.cbshTrueSyncClick(Sender: TObject);
begin
  MainData.shTrueSync := cbshTrueSync.Checked;
  Edited := True;
  VisibleSet();
end;

//****************************************************************************//
//   "   Windows"
procedure TfrmSettings.cbStartWithWindowsClick(Sender: TObject);
begin
  MainData.StartWithWindows := cbStartWithWindows.Checked;
  Edited := True;
end;

procedure TfrmSettings.CheckListShClickCheck(Sender: TObject);
begin
  Edited := True;
end;

procedure TfrmSettings.CheckListShSyncClickCheck(Sender: TObject);
begin
  Edited := True;
end;

end.
