unit ufrmSingleSetting;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  Mask,
  Buttons,
  uMain,
  ComCtrls,
  uExchange,
  FileCtrl;

type
  TfrmSingleSetting = class(TForm)
    EditName: TLabeledEdit;
    EditDBType: TComboBox;
    txtType: TLabel;
    EditDBPath: TLabeledEdit;
    EditDBUserName: TLabeledEdit;
    EditDBUserPassword: TLabeledEdit;
    EditExchangeCode: TLabeledEdit;
    btOK: TBitBtn;
    btClose: TBitBtn;
    StatusBar: TStatusBar;
    cbRunAfterExchange: TCheckBox;
    PanelAfter: TPanel;
    btSaveAfter: TBitBtn;
    EditAfterUserName: TLabeledEdit;
    EditAfterUserPassword: TLabeledEdit;
    picEditAfter: TImage;
    PageControlSS: TPageControl;
    TabSSMain: TTabSheet;
    TabSSOther: TTabSheet;
    GroupBoxBg: TGroupBox;
    GroupBoxBgUpdate: TGroupBox;
    rbWaitExchangeBg: TRadioButton;
    rbStopExchangeBg: TRadioButton;
    GroupBoxOtherSet: TGroupBox;
    GroupBoxOtherSetUpdate: TGroupBox;
    rbWaitExchange: TRadioButton;
    rbStopExchange: TRadioButton;
    cbRunExchangeIfRun: TCheckBox;
    cbExchange: TCheckBox;
    btSelectDBPath: TBitBtn;
    procedure btCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure EditDBTypeChange(Sender: TObject);
    procedure cbRunAfterExchangeClick(Sender: TObject);
    procedure btSaveAfterClick(Sender: TObject);
    procedure picEditAfterDblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure cbRunExchangeIfRunClick(Sender: TObject);
    procedure btSelectDBPathClick(Sender: TObject);
  private
    { Private declarations }
  public
  end;

var
  frmSingleSetting: TfrmSingleSetting;
  SingleSetting: Settings;

implementation

{$R *.dfm}

//****************************************************************************//
//          
procedure EnabledSetSingle();
begin
  frmSingleSetting.rbWaitExchange.Enabled := frmSingleSetting.cbRunExchangeIfRun.Checked;
  frmSingleSetting.rbStopExchange.Enabled := frmSingleSetting.cbRunExchangeIfRun.Checked;
end;

//****************************************************************************//
//     
procedure EnabledSet(Flag: Boolean);
begin
  frmSingleSetting.EditName.Enabled := Flag;
  frmSingleSetting.EditDBType.Enabled := Flag;
  frmSingleSetting.EditDBPath.Enabled := Flag;
  frmSingleSetting.EditDBUserName.Enabled := Flag;
  frmSingleSetting.EditDBUserPassword.Enabled := Flag;
  frmSingleSetting.EditExchangeCode.Enabled := Flag;
  frmSingleSetting.cbRunAfterExchange.Enabled := Flag;
  frmSingleSetting.btOK.Enabled := Flag;
  frmSingleSetting.btClose.Enabled := Flag;
  frmSingleSetting.txtType.Enabled := Flag;
end;

//****************************************************************************//
//     
procedure ReadSetting();
begin
  frmSingleSetting.cbExchange.Checked := SingleSetting.Exchange;
  frmSingleSetting.EditName.Text:=SingleSetting.Name;
  frmSingleSetting.EditDBType.ItemIndex:=SingleSetting.DBType;
  frmSingleSetting.EditDBPath.Text:=SingleSetting.DBPath;
  frmSingleSetting.EditDBUserName.Text:=SingleSetting.DBUserName;
  frmSingleSetting.EditDBUserPassword.Text:=SingleSetting.DBUserPassword;
  frmSingleSetting.EditExchangeCode.Text:=SingleSetting.ExchangeCode;

  frmSingleSetting.cbRunAfterExchange.Checked := SingleSetting.RunAfterExchange;
  frmSingleSetting.EditAfterUserName.Text :=  SingleSetting.AfterUserName ;
  frmSingleSetting.EditAfterUserPassword.Text := SingleSetting.AfterUserPassword;

  frmSingleSetting.cbRunExchangeIfRun.Checked := SingleSetting.RunExchangeIfRun;
  frmSingleSetting.rbWaitExchange.Checked := SingleSetting.WaitExchange;
  frmSingleSetting.rbStopExchangeBg.Checked := not SingleSetting.WaitExchangeBg;
end;


//****************************************************************************//

//     
procedure WriteSetting();
begin
  SingleSetting.Exchange := frmSingleSetting.cbExchange.Checked;
  SingleSetting.Name:=frmSingleSetting.EditName.Text;
  SingleSetting.DBType:=frmSingleSetting.EditDBType.ItemIndex;
  SingleSetting.DBPath:=frmSingleSetting.EditDBPath.Text;
  SingleSetting.DBUserName:=frmSingleSetting.EditDBUserName.Text;
  SingleSetting.DBUserPassword:=frmSingleSetting.EditDBUserPassword.Text;
  SingleSetting.ExchangeCode:=frmSingleSetting.EditExchangeCode.Text;

  SingleSetting.RunAfterExchange := frmSingleSetting.cbRunAfterExchange.Checked;
  SingleSetting.AfterUserName := frmSingleSetting.EditAfterUserName.Text;
  SingleSetting.AfterUserPassword := frmSingleSetting.EditAfterUserPassword.Text;

  SingleSetting.RunExchangeIfRun := frmSingleSetting.cbRunExchangeIfRun.Checked;
  SingleSetting.WaitExchange := frmSingleSetting.rbWaitExchange.Checked;
  SingleSetting.WaitExchangeBg := not frmSingleSetting.rbStopExchangeBg.Checked;
end;

//****************************************************************************//
//  
procedure TfrmSingleSetting.btCloseClick(Sender: TObject);
begin
  Close();
end;

//****************************************************************************//
//  
procedure TfrmSingleSetting.FormCreate(Sender: TObject);
begin
  //  
  ReadSetting();
end;

procedure TfrmSingleSetting.btOKClick(Sender: TObject);
var
  ErrorString: String;
  ComConnection: Variant;

begin
  //   
  ErrorString:='   :';
  if EditName.Text = '' then ErrorString:=ErrorString + #13#10 + '-  ;';
  if EditDBPath.Text = '' then
  begin
    if EditDBType.ItemIndex = 0 then
      ErrorString:=ErrorString + #13#10 + '-   ;'
    else
      ErrorString:=ErrorString + #13#10 + '-   ;';
  end;
  if EditDBUserName.Text = '' then ErrorString:=ErrorString + #13#10 + '-  ;';
  if EditExchangeCode.Text = '' then ErrorString:=ErrorString + #13#10 + '-   ;';

  if StrLen(PChar(ErrorString)) > 34 then
  begin
    MessageBox(Handle, PChar(ErrorString), ' ', MB_OK+MB_ICONASTERISK);
    ModalResult := mrNone;
    Exit;
  end;

  WriteSetting();

  //     
  if MainData.ConnectAdd then
  begin
    StatusBar.Panels.Items[0].Text:= '    ...';
    Refresh();
    try
      ComConnection:=CreateComConnection(SingleSetting);
    except
    on E:Exception do
      begin
        StatusBar.Panels.Items[0].Text:= '     ';
        MessageBox(Handle, PChar(E.Message), ' ', MB_OK+MB_ICONWARNING);
        WriteLog(51, '      ', E.Message, True);
        Exit;
      end;
    end;
  end;
end;

//****************************************************************************//
//  
procedure TfrmSingleSetting.FormShow(Sender: TObject);
begin
  //  
  ReadSetting();
  StatusBar.Panels.Items[0].Text:= '';
  //        
  PanelAfter.Visible := False;
  EnabledSet(True);
  EnabledSetSingle();
end;

//****************************************************************************//
//  
procedure TfrmSingleSetting.FormPaint(Sender: TObject);
begin
  //   
  if EditDBType.ItemIndex = 0 then
    begin
      btSelectDBPath.Enabled:=True;
      EditDBPath.EditLabel.Caption:='   '
    end
  else
  begin
      btSelectDBPath.Enabled:=False;
      EditDBPath.EditLabel.Caption:='  \    ';
  end;
end;

//****************************************************************************//
//   
procedure TfrmSingleSetting.EditDBTypeChange(Sender: TObject);
begin
  Refresh();
end;

//****************************************************************************//
//    
procedure TfrmSingleSetting.cbRunAfterExchangeClick(Sender: TObject);
begin
  if cbRunAfterExchange.Checked then
  begin
    //      
    EnabledSet(False);
    PanelAfter.Visible := True;
  end;
end;

//****************************************************************************//
//          
procedure TfrmSingleSetting.btSaveAfterClick(Sender: TObject);
begin
  PanelAfter.Visible := False;
  EnabledSet(True);
end;

//****************************************************************************//
//          
procedure TfrmSingleSetting.picEditAfterDblClick(Sender: TObject);
begin
  EnabledSet(False);
  PanelAfter.Visible := True;
end;

procedure TfrmSingleSetting.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  EnabledSet(True);
end;

//******************************************************************************//
//    
procedure TfrmSingleSetting.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then
    // ESC
    Close();
end;

//******************************************************************************//
//          
procedure TfrmSingleSetting.cbRunExchangeIfRunClick(Sender: TObject);
begin
  //  
  EnabledSetSingle();
end;

//****************************************************************************//
//   
procedure TfrmSingleSetting.btSelectDBPathClick(Sender: TObject);
var
  CatalogBD: String;
begin
  SelectDirectory('   ', '', CatalogBD);
  EditDBPath.Text:=CatalogBD;
end;

end.
