unit ufrmSingleSync;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Buttons, uMain, FileCtrl, Mask,
  Spin;

type
  TfrmSingleSync = class(TForm)
    PageControlSync: TPageControl;
    TabSheetMainSync: TTabSheet;
    TabSheetOtherSync: TTabSheet;
    EditName: TLabeledEdit;
    EditHost: TLabeledEdit;
    EditUser: TLabeledEdit;
    EditPassword: TLabeledEdit;
    cbPassive: TCheckBox;
    cbTransferType: TComboBox;
    txtTransferType: TLabel;
    GroupBoxLocal: TGroupBox;
    EditLocalInbox: TLabeledEdit;
    EditLocalOutbox: TLabeledEdit;
    EditLocalMask: TLabeledEdit;
    GroupBoxRemote: TGroupBox;
    EditRemoteInbox: TLabeledEdit;
    EditRemoteOutbox: TLabeledEdit;
    EditRemoteMask: TLabeledEdit;
    btOK: TBitBtn;
    btClose: TBitBtn;
    GroupBoxProxy: TGroupBox;
    EditSHost: TLabeledEdit;
    EditSUser: TLabeledEdit;
    EditSPassword: TLabeledEdit;
    tstSVersion: TLabel;
    cbSVersion: TComboBox;
    GroupBoxLock: TGroupBox;
    EditLockExt: TLabeledEdit;
    btOpenLocalInboxDir: TBitBtn;
    btOpenLocalOutboxDir: TBitBtn;
    cbExchange: TCheckBox;
    Label1: TLabel;
    EditUnlockWait: TSpinEdit;
    EditPort: TSpinEdit;
    txtPort: TLabel;
    txtSPort: TLabel;
    EditSPort: TSpinEdit;
    procedure SSSS(Sender: TObject);
    procedure btOpenLocalInboxDirClick(Sender: TObject);
    procedure btOpenLocalOutboxDirClick(Sender: TObject);
    procedure btOKClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSingleSync: TfrmSingleSync;
  SingleSync: SettingsSync;

implementation

{$R *.dfm}
//*******************************************************************************//
//   
procedure TfrmSingleSync.SSSS(Sender: TObject);
begin
  //  
  //  
  EditName.Text := SingleSync.Name;
  EditHost.Text := SingleSync.Host;
  EditUser.Text := SingleSync.User;
  EditPassword.Text := SingleSync.Password;
  EditPort.Value := SingleSync.Port;
  EditLocalInbox.Text := SingleSync.LocalInbox;
  EditLocalOutbox.Text := SingleSync.LocalOutbox;
  EditLocalMask.Text := SingleSync.LocalMask;
  EditRemoteInbox.Text := SingleSync.RemoteInbox;
  EditRemoteOutbox.Text := SingleSync.RemoteOutbox;
  EditRemoteMask.Text := SingleSync.RemoteMask;
  EditSHost.Text := SingleSync.SHost;
  EditSPort.Value := SingleSync.SPort;
  EditSUser.Text := SingleSync.SUser;
  EditSPassword.Text := SingleSync.SPassword;
  EditLockExt.Text := SingleSync.LockExt;
  EditUnlockWait.Value := SingleSync.UnlockWait;

  // 
  if SingleSync.TransferType = 'Binary' then
    cbTransferType.ItemIndex := 0
  else
    cbTransferType.ItemIndex := 1;

  if SingleSync.SVersion = ' ' then
    cbSVersion.ItemIndex := 0
  else if SingleSync.SVersion = 'SOCKS4' then
    cbSVersion.ItemIndex := 1
  else if SingleSync.SVersion = 'SOCKS4A' then
    cbSVersion.ItemIndex := 2
  else
    cbSVersion.ItemIndex := 3;

  // 
  cbPassive.Checked := SingleSync.Passive;
  cbExchange.Checked := SingleSync.Exchange;
end;

//*******************************************************************************//
//     
procedure TfrmSingleSync.btOpenLocalInboxDirClick(Sender: TObject);
var
  Catalog: String;
begin
  SelectDirectory('  ', '', Catalog);
  EditLocalInbox.Text := Catalog;
end;

//*******************************************************************************//
//     
procedure TfrmSingleSync.btOpenLocalOutboxDirClick(Sender: TObject);
var
  Catalog: String;
begin
  SelectDirectory('  ', '', Catalog);
  EditLocalOutbox.Text := Catalog;
end;

procedure TfrmSingleSync.btOKClick(Sender: TObject);
var
  ErrorString: String;
begin
  //   
  ErrorString:='   :';
  if EditName.Text = '' then ErrorString:=ErrorString + #13#10 + '-  ;';
  if EditHost.Text = '' then ErrorString:=ErrorString + #13#10 + '-  ;';
  if EditPort.Text = '' then ErrorString:=ErrorString + #13#10 + '- ;';
  if EditUser.Text = '' then ErrorString:=ErrorString + #13#10 + '-  ;';
  if (EditLocalInbox.Text = '') and (EditLocalOutbox.Text = '') then ErrorString:=ErrorString + #13#10 + '-       ;';
  if EditLocalMask.Text = '' then ErrorString:=ErrorString + #13#10 + '-   ;';
  if (EditRemoteInbox.Text = '') and (EditRemoteOutbox.Text = '') then ErrorString:=ErrorString + #13#10 + '-       FTP;';
  if EditRemoteMask.Text = '' then ErrorString:=ErrorString + #13#10 + '-   FTP;';
  if EditLockExt.Text = '' then ErrorString:=ErrorString + #13#10 + '-   ;';

  if StrLen(PChar(ErrorString)) <= 34 then
  begin
    //  
    ErrorString := '';
    //  ,   
    if EditLocalInbox.Text = EditLocalOutbox.Text then
    begin
      ErrorString:=ErrorString + #13#10 + '-      !';
    end;
    if EditRemoteInbox.Text = EditRemoteOutbox.Text then
    begin
      ErrorString:=ErrorString + #13#10 + '-   FTP   !';
    end;
  end;

  if StrLen(PChar(ErrorString)) > 1 then
  begin
    MessageBox(Handle, PChar(ErrorString), ' ', MB_OK+MB_ICONASTERISK);
    ModalResult := mrNone;
    Exit;
  end;

  //  
  //  
  SingleSync.Name := EditName.Text;
  SingleSync.Host := EditHost.Text;
  SingleSync.User := EditUser.Text;
  SingleSync.Password := EditPassword.Text;
  SingleSync.Port := EditPort.Value;
  SingleSync.LocalInbox := EditLocalInbox.Text;
  SingleSync.LocalOutbox := EditLocalOutbox.Text;
  SingleSync.LocalMask := EditLocalMask.Text;
  SingleSync.RemoteInbox := EditRemoteInbox.Text;
  SingleSync.RemoteOutbox := EditRemoteOutbox.Text;
  SingleSync.RemoteMask := EditRemoteMask.Text;
  SingleSync.SHost := EditSHost.Text;
  SingleSync.SPort := EditSPort.Value;
  SingleSync.SUser := EditSUser.Text;
  SingleSync.SPassword := EditSPassword.Text;
  SingleSync.LockExt := EditLockExt.Text;
  SingleSync.UnlockWait := EditUnlockWait.Value;

  // 
  if cbTransferType.ItemIndex = 0 then
    SingleSync.TransferType := 'Binary'
  else
    SingleSync.TransferType := 'ASCII';

  if cbSVersion.ItemIndex = 0 then
    SingleSync.SVersion := ' '
  else if cbSVersion.ItemIndex = 1 then
    SingleSync.SVersion := 'SOCKS4'
  else if cbSVersion.ItemIndex = 2 then
    SingleSync.SVersion := 'SOCKS4A'
  else
    SingleSync.SVersion := 'SOCKS5';

  // 
  SingleSync.Passive := cbPassive.Checked;
  SingleSync.Exchange := cbExchange.Checked;
end;

//*******************************************************************************************//
//      
procedure TfrmSingleSync.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #27 then
    Close();
end;

end.
